/*
 *  Common.h
 *  GlowWorm
 *
 *  Created by Curtis Jones on 2006.06.09.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __COMMON_H__
#define __COMMON_H__

#include <stdint.h>

#define GW_CREATOR															0xCAFEBABE			// first four bytes of gw files

#define GW_ACT1_CONN														0x00000001			// connection
#define GW_ACT1_DATA														0x00000002			// data
#define GW_ACT1_PROC														0x00000004			// process
#define GW_ACT1_RULE														0x00000008			// rule
#define GW_ACT1_ADDR														0x00000010			// address
#define GW_ACT1_REGC														0x00000020			// registration code
#define GW_ACT1_SYST														0x00000040			// system message
#define GW_ACT1_LOGR														0x00000080			// logger
#define GW_ACT1_INTF														0x00000100			// interface

#define GW_ACT2_INSERT													0x00000001			// insert
#define GW_ACT2_UPDATE													0x00000002			// update
#define GW_ACT2_DELETE													0x00000004			// delete
#define GW_ACT2_SELECT													0x00000008			// select
#define GW_ACT2_AUTH														0x00000010			// alow
#define GW_ACT2_LOOKUP													0x00000020			// lookup
#define GW_ACT2_LOG															0x00000040			// log
#define GW_ACT2_CHANGE													0x00000080			// change

#define GW_ACT3_GOOD														0x00000001			// good
#define GW_ACT3_BAD															0x00000002			// bad
#define GW_ACT3_NOLIST													0x00000004			// no such list
#define GW_ACT3_NORULE													0x00000008			// no such rule
#define GW_ACT3_NOMEM														0x00000010			// no memory
#define GW_ACT3_ALLOW														0x00000020			// alow
#define GW_ACT3_DENY														0x00000040			// deny
#define GW_ACT3_DEFER														0x00000080			// defer
#define GW_ACT3_BUSY														0x00000100			// busy
#define GW_ACT3_DONE														0x00000200			// done
#define GW_ACT3_ILLEGAL													0x00000400			// illegal
#define GW_ACT3_EXPIRED													0x00000800			// expired
#define GW_ACT3_RESTRICTED											0x00001000			// restricted (ie, registration code limitations)
#define GW_ACT3_NOTFOUND												0x00002000			// not found (should replace NORULE)
#define GW_ACT3_LOGR_RULES											0x00004000			// logr rules list
#define GW_ACT3_LOGR_DATES											0x00008000			// logr date list for a rule
#define GW_ACT3_ERROR														0x00010000			// error

#define GW_REGC_HASH_SHA1												0x00000001			// registration code - hash type - sha1
#define GW_REGC_HASH_SHA2_128										0x00000002			// registration code - hash type - sha2-128
#define GW_REGC_HASH_SHA2_256										0x00000003			// registration code - hash type - sha2-256
#define GW_REGC_HASH_SHA2_384										0x00000004			// registration code - hash type - sha2-384
#define GW_REGC_HASH_SHA2_512										0x00000005			// registration code - hash type - sha2-512

#define GW_REGC_ALGO_RSA												0x00000001			// registration code - signature algorithm - rsa
#define GW_REGC_ALGO_DSA												0x00000002			// registration code - signature algorithm - dsa
#define GW_REGC_ALGO_ELGAMAL										0x00000003			// registration code - signature algorithm - elgamal
#define GW_REGC_ALGO_CRAMER_SHOUP								0x00000004			// registration code - signature algorithm - cramer-shoup

#define GW_REGC_DATA_PLISTXML										0x00000001			// registration code - data format - plist xml
#define GW_ERGC_DATA_PLISTBIN										0x00000002			// registration code - data format - plist binary

#define GW_PRODUCT_LITE													0x00000001			// glowworm - product - lite		(free)
#define GW_PRODUCT_REG													0x00000002			// glowworm - product - regular ($30)
#define GW_PRODUCT_PRO													0x00000004			// glowworm - product - pro			($100)
#define GW_PRODUCT_FULL													0x00000008			// glowworm - product - full		(priceless)





#define GWR_LOCA_BEG														0x10000000			// rule - location - beginning
#define GWR_LOCA_END														0x20000000			// rule - location - end

#define GWR_ENDPOINT_LOCAL											0x00000001			// rule - endpoint - local
#define GWR_ENDPOINT_REMOTE											0x00000002			// rule - endpoint - remote
#define GWR_ENDPOINT_EITHER											0x00000004			// rule - endpoint - either

#define GWR_CAT_NONE														0x00000001			// rule - category - none
#define GWR_CAT_MAIN														0x00000002			// rule - category - main
#define GWR_CAT_SYST														0x00000004			// rule - category - system
#define GWR_CAT_QUIT														0x00000008			// rule - category - quit
#define GWR_CAT_REBT														0x00000010			// rule - category - reboot

#define GWR_MESGSIZE_FULL												0x00000001			// rule - message size - full
#define GWR_MESGSIZE_MINI												0x00000002			// rule - message size - mini

#define GWS_ACTION_ATTACH												0x00000001			// socket - action - attach
#define GWS_ACTION_DETACH												0x00000002			// socket - action - detach
#define GWS_ACTION_CONNECT											0x00000004			// socket - action - connect
#define GWS_ACTION_BIND													0x00000008			// socket - action - bind
#define GWS_ACTION_SETOPTION										0x00000010			// socket - action - set option
#define GWS_ACTION_GETOPTION										0x00000020			// socket - action - get option
#define GWS_ACTION_LISTEN												0x00000040			// socket - action - listen
#define GWS_ACTION_IOCTL												0x00000080			// socket - action - ioctl

#define GWS_STATE_CONNECTING										0x00000001			// socket - state - connecting
#define GWS_STATE_CONNECTED											0x00000002			// socket - state - connected
#define GWS_STATE_DISCONNECTING									0x00000004			// socket - state - disconnecting
#define GWS_STATE_DISCONNECTED									0x00000008			// socket - state - disconnected
#define GWS_STATE_FLUSH_READ										0x00000010			// socket - state - flush read
#define GWS_STATE_SHUTDOWN_SEND									0x00000020			// socket - state - shutdown send
#define GWS_STATE_SHUTDOWN_RECV									0x00000040			// socket - state - shutdown receive
#define GWS_STATE_SHUTDOWN_BOTH									0x00000080			// socket - state - shutdown both
#define GWS_STATE_CANT_RECV_MORE								0x00000100			// socket - state - can't receive more
#define GWS_STATE_CANT_SEND_MORE								0x00000200			// socket - state - can't send more
#define GWS_STATE_CLOSING												0x00000400			// socket - state - closing
#define GWS_STATE_UNKNOWN												0x00000800			// socket - state - unknown

#define GW_OBJECT_CONN													0x00000001			// Conn
#define GW_OBJECT_DATA													0x00000002			// Data
#define GW_OBJECT_MESG													0x00000004			// Mesg
#define GW_OBJECT_RULE													0x00000008			// Rule
#define GW_OBJECT_ADDR													0x00000010			// Addr - for dns resolution, mostly
#define GW_OBJECT_REGC													0x00000020			// Registration code
#define GW_OBJECT_PROC													0x00000040			// Process
#define GW_OBJECT_LOGR													0x00000080			// Logger
#define GW_OBJECT_INTF													0x00000100			// Interface
#define GW_OBJECT_SYST													0x00000200			// System





#define GWP_ACTION_EXEC													0x00000001			// execute (file or dir)





#define GW_PRODUCT_LITE_01											0x000101			// GlowWorm FW Lite		- v1.0
#define GW_PRODUCT_REG_01												0x000201			// GlowWorm FW				- v1.0
#define GW_PRODUCT_PRO_01												0x000401			// GlowWorm FW Pro		- v1.0
#define GW_PRODUCT_ADMIN_01											0x000801			// GlowWorm FW Admin	- v1.0

#define GWS_EVENT_MODE_SET											0x0001				// set
#define GWS_EVENT_MODE_UNSET										0x0002				// unset
#define GWS_EVENT_MODE_ALLOW										0x0004				// allow
#define GWS_EVENT_MODE_DENY											0x0008				// deny
#define GWS_EVENT_MODE_ERROR										0x0010				// error
#define GWS_EVENT_MODE_QUERY										0x0020				// query
#define GWS_EVENT_MODE_DNS											0x0040				// dns resolve (SET | UNSET)
#define GWS_EVENT_MODE_RULE											0x0080				// rule change (SET | UNSET)
#define GWS_EVENT_MODE_GET											0x0100				// get
#define GWS_EVENT_MODE_GOOD											0x0200				// good
#define GWS_EVENT_MODE_BAD											0x0400				// bad

#define GWS_GLOBAL_EVENT												0x0000				// global

#define GWS_EVENT_DATA													0x01000000lu	// event category - data
#define GWS_EVENT_DATA_SEND											0x01010000lu	// event category - data send
#define GWS_EVENT_DATA_RECV											0x01020000lu	// event category - data receive
#define GWS_EVENT_CONN													0x02000000lu	// event category - conn
#define GWS_EVENT_CONN_SEND											0x02010000lu	// event category - connection outgoing
#define GWS_EVENT_CONN_RECV											0x02020000lu	// event category - connection incoming
#define GWS_EVENT_CONN_STATE										0x02040000lu	// event category - connection state
#define GWS_EVENT_REGC													0x04000000lu	// event category - regc
#define GWS_EVENT_REGC_INSTALL									0x04010000lu	// event category - registration code install
#define GWS_EVENT_ERROR													0x08000000lu	// event category - error
#define GWS_EVENT_RULE													0x10000000lu	// event category - rule

#define GWS_EVENT_DATA_SEND_OFF									0x01010100		// event type - data send - off
#define GWS_EVENT_DATA_SEND_INFO								0x01010200		// event type - data send - per-packet data_in()/data_out() messages
#define GWS_EVENT_DATA_SEND_DATA								0x01010400		// event type - data send - data
#define GWS_EVENT_DATA_SEND_AUTH								0x01010800		// event type - data send - authorize each packet

#define GWS_EVENT_DATA_RECV_OFF									0x01020100		// event type - data receive - off
#define GWS_EVENT_DATA_RECV_INFO								0x01020200		// event type - data receive - general information
#define GWS_EVENT_DATA_RECV_DATA								0x01020400		// event type - data receive - data
#define GWS_EVENT_DATA_RECV_AUTH								0x01020800		// event type - data receive - authorization

#define GWS_EVENT_CONN_SEND_OFF									0x02010100		// event type - connection outgoing - off
#define GWS_EVENT_CONN_SEND_INFO								0x02010200		// event type - connection outgoing - connection state changes
#define GWS_EVENT_CONN_SEND_AUTH								0x02010400		// event type - connection outgoing - authorize new connections
#define GWS_EVENT_CONN_SEND_STAT								0x02010800		// event type - connection outgoing - aggregated connection statistics

#define GWS_EVENT_CONN_RECV_OFF									0x02020100		// event type - connection incoming - off
#define GWS_EVENT_CONN_RECV_INFO								0x02020200		// event type - connection incoming - general information
#define GWS_EVENT_CONN_RECV_AUTH								0x02020400		// event type - connection incoming - authorization
#define GWS_EVENT_CONN_RECV_STAT								0x02020800		// event type - connection incoming - statistics

#define GWS_EVENT_CONN_STATE_CONNECTING					0x02040100		// event type - connection state - connecting
#define GWS_EVENT_CONN_STATE_CONNECTED					0x02040200		// event type - connection state - connected
#define GWS_EVENT_CONN_STATE_DISCONNECTING			0x02040300		// event type - connection state - disconnecting
#define GWS_EVENT_CONN_STATE_DISCONNECTED				0x02040400		// event type - connection state - disconnected
#define GWS_EVENT_CONN_STATE_FLUSH_READ					0x02040500		// event type - connection state - flush read
#define GWS_EVENT_CONN_STATE_SHUTDOWN_SEND			0x02040600		// event type - connection state - shutdown send
#define GWS_EVENT_CONN_STATE_SHUTDOWN_RECV			0x02040700		// event type - connection state - shutdown receive
#define GWS_EVENT_CONN_STATE_SHUTDOWN_BOTH			0x02040800		// event type - connection state - shutdown both
#define GWS_EVENT_CONN_STATE_CANT_RECV_MORE			0x02040900		// event type - connection state - can't receive more
#define GWS_EVENT_CONN_STATE_CANT_SEND_MORE			0x02040a00		// event type - connection state - can't send more
#define GWS_EVENT_CONN_STATE_CLOSING						0x02040b00		// event type - connection state - closing
#define GWS_EVENT_CONN_STATE_UNKNOWN						0x02040c00		// event type - connection state - unknown

#define GWS_EVENT_REGC_INSTALL_INSTALL					0x04010100		// event type - registration install - install

#define GWS_EVENT_ERROR_NOPERM									0x08010000		// error - not permitted
#define GWS_EVENT_ERROR_BADREQ									0x08020000		// error - bad request
#define GWS_EVENT_ERROR_BADSIG									0x08040000		// error - bad signature
#define GWS_EVENT_ERROR_NOCONN									0x00080000		// error - no connection
#define GWS_EVENT_ERROR_OKAY										0x08100000		// error - okay; no error
#define GWS_EVENT_ERROR_NOMEM										0x08200000		// error - no memory

#define GWS_REGC_HASH_SHA1											0x00000001		// registration code - hash type - sha1
#define GWS_REGC_HASH_SHA2_128									0x00000002		// registration code - hash type - sha2-128
#define GWS_REGC_HASH_SHA2_256									0x00000003		// registration code - hash type - sha2-256
#define GWS_REGC_HASH_SHA2_384									0x00000004		// registration code - hash type - sha2-384
#define GWS_REGC_HASH_SHA2_512									0x00000005		// registration code - hash type - sha2-512

#define GWS_REGC_ALGO_RSA												0x00000001		// registration code - signature algorithm - rsa
#define GWS_REGC_ALGO_DSA												0x00000002		// registration code - signature algorithm - dsa
#define GWS_REGC_ALGO_ELGAMAL										0x00000003		// registration code - signature algorithm - elgamal
#define GWS_REGC_ALGO_CRAMER_SHOUP							0x00000004		// registration code - signature algorithm - cramer-shoup

#define GWS_REGC_DATA_PLISTXML									0x00000001		// registration code - data format - plist xml
#define GWS_ERGC_DATA_PLISTBIN									0x00000002		// registration code - data format - plist binary





#define GWS_SOPT_PIDTOPATH											0x7F000000		// getsockopt - process id to absolute path

#define GWS_CONN_DIR_INCOMING										0x00000001		// incoming connection
#define GWS_CONN_DIR_OUTGOING										0x00000002		// outgoing connection
#define GWS_CONN_DIR_LISTENER										0x00000004		// listener connection

#define GWS_PROTO_TCP														0x00000001		// proto - tcp
#define GWS_PROTO_UDP														0x00000002		// proto - udp
#define GWS_PROTO_ANY														0x00000004		// proto - any

#define GWR_ONOFF_ON														0x00000001		// rule onoff - on
#define GWR_ONOFF_OFF														0x00000002		// rule onoff - off

#define GWR_LOG_ON															0x00000001		// rule log - on
#define GWR_LOG_OFF															0x00000002		// rule log - off

#define GWR_CONTINUE_YES												0x00000001		// rule continue - yes
#define GWR_CONTINUE_NO													0x00000002		// rule continue - no

#define GWR_TERM_PERM														0x00000001		// rule term - perm
#define GWR_TERM_TEMP														0x00000002		// rule term - temp

#define GWR_PROTO_TCP														0x00000001		// proto - tcp
#define GWR_PROTO_UDP														0x00000002		// proto - udp
#define GWR_PROTO_ANY														0x00000004		// proto - any

#define GWR_THROTTLE_NONE												0x00000000		// throttle - none

#define GWR_STATS_ON														0x00000001		// dostats - on
#define GWR_STATS_OFF														0x00000002		// dostats - off
#define GWR_STATS_NONE													0x00000004		// dostats - none

#define GWR_DIRECTION_NONE											0x00000001		// 
#define GWR_DIRECTION_BOTH											0x00000002		// 
#define GWR_DIRECTION_INC												0x00000004		// 
#define GWR_DIRECTION_OUT												0x00000008		// 
#define GWR_DIRECTION_LSTN											0x00000010		// 

#define GWR_LIST_NONE														0x00000001		// rule list - none
#define GWR_LIST_CONN														0x00000002		// rule list - conn
#define GWR_LIST_DATA														0x00000004		// rule list - data
#define GWR_LIST_PROC														0x00000008		// rule list - proc

#define GWR_TYPE_NONE														0x00000001		// rule type - none
#define GWR_TYPE_AUTH														0x00000002		// rule type - auth
#define GWR_TYPE_DATA														0x00000004		// rule type - data
#define GWR_TYPE_INFO														0x00000008		// rule type - info
#define GWR_TYPE_STAT														0x00000010		// rule type - stat

#define GWR_CALL_NONE														0x00000001		// rule calling - none
#define GWR_CALL_AUTH														0x00000002		// rule calling - authorizer
#define GWR_CALL_LOGR														0x00000004		// rule calling - logger

#define GWR_ACTION_NONE													0x00000001		// rule action - none
#define GWR_ACTION_ALLOW												0x00000002		// rule action - allow
#define GWR_ACTION_DENY													0x00000004		// rule action - deny
#define GWR_ACTION_ASK													0x00000008		// rule action - ask

#define GWR_RACTION_SOUND												0x00000001		// rule action - sound
#define GWR_RACTION_SCRIPT											0x00000002		// rule action - script
#define GWR_RACTION_EMAIL												0x00000004		// rule action - email
#define GWR_RACTION_ALERT												0x00000008		// rule action - alert
#define GWR_RACTION_CHANGE											0x00000010		// rule action - change

#define GW_ADDR_TYPE_NAME												0x00000001		// address type - name
#define GW_ADDR_TYPE_ADDR												0x00000002		// address type - numerical

#define GW_LOGR_POSITION_BEG										0x00000000		// logger - start position - beginning
#define GW_LOGR_POSITION_END										0xF0000000		// logger - start position - end

#define GW_INTF_TYPE_UNKNOWN										0x00000001		// interface - type - unknown
#define GW_INTF_TYPE_ANY												0x00000002		// interface - type - any
#define GW_INTF_TYPE_WIRED											0x00000004		// interface - type - wired
#define GW_INTF_TYPE_WIRELESS										0x00000008		// interface - type - wireless





/*
struct GlowWormRuleUpdt
{
	uint32_t			gwr_id;						// rule id
	
	uint32_t			gwr_src_list;			// conn, data, proc
	uint32_t			gwr_src_term;			// perm, temp
	uint32_t			gwr_src_loca;			// index within list
	
	uint32_t			gwr_dst_list;			// conn, data, proc
	uint32_t			gwr_dst_term;			// perm, temp
	uint32_t			gwr_dst_loca;			// index within list
};





struct GlowWormEventHead {						// header for all events
	uint32_t		size;										// size of the message
	uint32_t		type;										// one of GWS_EVENT_*
	uint32_t		sock;										// socket id
	uint32_t		hand;										// event handler id
	uint32_t		mode;										// set? unset? allow? deny?
	uint32_t		tran;										// transaction id
};
typedef struct GlowWormEventHead GlowWormEventHead;

struct GlowWormEventConn {						// connection event (open, close, auth, etc.)
	char				addr[16];								// ip address
	uint32_t		port;										// ip port
	uint32_t		pid;										// process id
	uint32_t		uid;										// user id
	uint32_t		dir;										// direction (incoming, outgoing)
	uint32_t		proto;									// protocol (tcp, udp)
};
typedef struct GlowWormEventConn GlowWormEventConn;

struct GlowWormEventData {						// 
	uint32_t packetid;									// 
	uint32_t size;											// 
	uint64_t bytes;											// for "info", number of new bytes
	uint64_t pckts;											// for "info", number of new packets
	unsigned char * data;								// 
};
typedef struct GlowWormEventData GlowWormEventData;


struct GlowWormEventRegc {						// registration code install
	uint32_t	regc_hash;								// hash type   - GWS_REGC_HASH_*
	uint32_t	regc_algo;								// algorithm   - GWS_REGC_ALGO_*
	uint32_t	regc_data;								// data format - GWS_REGC_DATA_*
	uint8_t		regc_dsig_r[256];					// signature   - r
	uint8_t		regc_dsig_s[256];					// signature   - s
	uint8_t		regc_code[1000];					// registration code text
	uint32_t	regc_cleng;								// registratino code text length
	uint32_t	regc_rleng;								// signature length for r
	uint32_t	regc_sleng;								// signature length for s
};
typedef struct GlowWormEventRegc GlowWormEventRegc;


struct GlowWormSocketInfo {
	size_t			gwi_len;								// size of structure
	uint32_t		gwi_state;							// GWS_CONNECT_IN or GWS_CONNECT_OUT
	long				gwi_genid;							// 
	
	struct sockaddr_in	gwi_local;			// local endpoint
	struct sockaddr_in	gwi_remote;			// remote endpoint
	
	uint32_t		gwi_bytes_in;						// 
	uint32_t		gwi_pkts_in;						// 
	uint32_t		gwi_bytes_out;					// 
	uint32_t		gwi_pkts_out;						// 
	
	struct timeval	gwi_create;					// socreate timestamp
	struct timeval	gwi_start;					// connection complete timestamp
	struct timeval	gwi_stop;						// connection termination timestamp
	
	pid_t		gwi_pid;										// pid that created the socket
	pid_t		gwi_uid;										// uid that created the socket
};
*/

#endif /* __COMMON_H__ */
