/*
 *  string.h
 *  GlowWorm
 *
 *  Created by Curtis Jones on 2006.08.01.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __STRING_H__
#define __STRING_H__

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <strings.h>

#include <string.h>
#include <stdarg.h>

#include <crypto_common.h>

#define STRING_CSTR			-2

#define STRING_MAX(a,b) ((a) > (b) ? (a) : (b))
#define STRING_MIN(a,b) ((a) < (b) ? (a) : (b))

struct string
{
	int							s_leng;				// length of string
	int							s_size;				// size of malloc'ed space
	int							s_offs;				// data offset in s_data
	unsigned char * s_data;				// string data
};
typedef struct string * string_t;


string_t string_alloc ();
void string_free (string_t);

int string_set_bytes (string_t, unsigned char *, int len);
int string_appendf (string_t s, unsigned char *fmt, ...);
int string_append (string_t, unsigned char *, int len);
int string_append_str (string_t dst, string_t src);
void string_clear (string_t);

unsigned char * string_get_bytes (string_t);
int string_skip (string_t, int len);
int string_copy (string_t, unsigned char *, int src_offs, int dst_offs, int len);
#ifndef GW_KEXT
  int string_write (string_t, FILE *, int src_offs, int len);
#endif

int string_indexof (string_t, unsigned char *, int len);
int string_indexof_after (string_t, unsigned char *, int len, int offs);
int string_length (string_t);

string_t string_substring (string_t, int off, int len);

int string_equals (string_t, unsigned char *, int len);
int string_equals_str (string_t, string_t);
int string_startswith (string_t, unsigned char *, int len);
int string_endswith (string_t, unsigned char *, int len);

int string_grow (string_t, int size);
int __string_grow (string_t, int size);
void __string_set_leng (string_t, int leng);
void __string_shift (string_t);

#endif /* __STRING_H__ */
